#include <math.h>
#include "Hoja.h"

//--------------------------------------------------------------------------------------------------------------------------------
// Void constructor
// Parameters --> None
//--------------------------------------------------------------------------------------------------------------------------------
Hoja::Hoja(void) 
{	
	Vert_Hoja[0] = Vert_Hoja[1] = Vert_Hoja[2] = Vert_Hoja[3] =0; 
	Centro[0] = Centro[1] = Centro[2] = 0;
	Normal[0] = Normal[1] = Normal[2] = 0;
	hoja_cerca=-1;
	Cuantas_hojas = 1;
	dist = coplanar = criterio = hoja_cop = hoja_crit =-1;
	existe = true;
	padre=-1;
	hijoi = hijod = -1;
	raiz= visible= -1;
}


//--------------------------------------------------------------------------------------------------------------------------------
// Copy constructor
// Parameters --> const Hoja& aHoja : The Hoja to copy
//--------------------------------------------------------------------------------------------------------------------------------
Hoja::Hoja (const Hoja& aHoja)
{
	Cuantas_hojas = aHoja.Cuantas_hojas;;
	hoja_cerca = aHoja.hoja_cerca;
	hoja_crit = aHoja.hoja_crit;
	dist = aHoja.dist;
	existe = aHoja.existe;
	coplanar = aHoja.coplanar;
	hoja_cop = aHoja.hoja_cop;
	criterio = aHoja.criterio;
	for ( int i=0;i<3;i++){
		Centro[i] = aHoja.Centro[i];
		Normal[i] = aHoja.Normal[i];
	}
	for (i = 0L; i < 4; i++)
		Vert_Hoja[i] = aHoja.Vert_Hoja[i]; 
	
	padre = aHoja.padre;
	hijoi = aHoja.hijoi;
	hijod = aHoja.hijod;
	visible = aHoja.visible;
	raiz = aHoja.raiz;
}



//--------------------------------------------------------------------------------------------------------------------------------
// Destructor. We must deallocate the memory allocated for pointers to vertices and edges
//--------------------------------------------------------------------------------------------------------------------------------
Hoja::~Hoja (void)
{
}


//--------------------------------------------------------------------------------------------------------------------------------
//  CALCULA LA DISTANCIA ENTRE HOJAS
//--------------------------------------------------------------------------------------------------------------------------------

float Hoja::Distancia (Hoja& Hoja1)
{
	float dist =0;
	float x1,y1,z1;

	x1 = Hoja1.Centro[0]; y1 = Hoja1.Centro[1] ; z1 = Hoja1.Centro[2];


	//DISTANCIA ENTRE CENTROS

	dist = ((Centro[0]-x1)*(Centro[0]-x1)) + ((Centro[1]-y1)*(Centro[1]-y1)) + ((Centro[2]-z1)*(Centro[2]-z1));

	return (dist);
}


//--------------------------------------------------------------------------------------------------------------------------------
//  CALCULA LA COPLANARIDAD ENTRE HOJAS
//--------------------------------------------------------------------------------------------------------------------------------

float Hoja::Coplanaridad (Hoja& Hoja1)
{
	float cop =0;
	float modulo1, modulo2;
	float x1,y1,z1, nx1, ny1, nz1;
	float nx, ny, nz;

	//hoja pasada como parametro, normalizo las componentes
	x1 = Hoja1.Normal[0]; y1 = Hoja1.Normal[1] ; z1 = Hoja1.Normal[2];
	modulo1 = sqrt ( (x1*x1) + (y1*y1) + (z1*z1));
	nx1 = x1 / modulo1;
	ny1 = y1 / modulo1;
	nz1 = z1 / modulo1;

	// hoja desde la que llamo

	modulo2 = sqrt ( (Normal[0]*Normal[0]) + (Normal[1]*Normal[1]) + (Normal[2]*Normal[2]));
	nx = Normal[0] / modulo2;
	ny = Normal[1] / modulo2;
	nz = Normal[2] / modulo2;

	// producto escalar : si es proximo a 0, perpendiculares, a 1, coplanares

	cop = (nx1*nx) + (ny1*ny) + (nz1*nz);


	return (fabs(cop));

}

